#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"
#include "AppRsc.h"
#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif


#include "PNOMain.h"

#include "unzip.h"

#include "timidity.h"

void Sys_PrintF( char *s, ...);
void Sys_PrintF2( char *s, ...);

UInt32 mStopEmulation=0;

char gpstr[256]; //used for general debugging purpose
char wad_filename[256];
char pwad_filename[256];

extern int		myargc;
extern char**		myargv;


extern int SCREENWIDTH;
extern int SCREENHEIGHT;

extern int g_scr_rotated;
extern int g_music_mode;

void ClearScreen(void);

unsigned int g_confinput[30];

unsigned long Run()
{
	UInt32 max, bytes;
	UInt32 result,penDown;
	char *ftrptr;
	

//  	MemHeapFreeBytes ( 0, &bytes, &max );
//  	Sys_PrintF("free ram : %d/%d",bytes>>10,max>>10);
//menu_info(" ");


	
	
	FtrGet(CREATORID,FTR_VIDEO_RESX_ID ,(unsigned long*)&SCREENWIDTH);
	FtrGet(CREATORID,FTR_VIDEO_RESY_ID ,(unsigned long*)&SCREENHEIGHT);
	FtrGet(CREATORID,FTR_VIDEO_ROT_ID ,(unsigned long*)&g_scr_rotated);		
	FtrGet(CREATORID,FTR_WAD_FILENAME_ID ,(unsigned long*)&ftrptr);    	
	FtrGet(CREATORID,FTR_MUSIC_MODE_ID ,(unsigned long*)&g_music_mode);
    strcpy(wad_filename,ftrptr);    
    FtrPtrFree(CREATORID, FTR_WAD_FILENAME_ID);          		
    FtrGet(CREATORID,FTR_PWAD_FILENAME_ID ,(unsigned long*)&ftrptr);
    strcpy(pwad_filename,ftrptr);
	FtrPtrFree(CREATORID, FTR_WAD_FILENAME_ID);          			       
    FtrGet(CREATORID,FTR_OPT_INPUTCONF_ID ,(unsigned long*)&ftrptr);
	for (int i=0;i<30;i++) g_confinput[i]=ByteSwap32(((UInt32*)ftrptr)[i]);    
        
	myargc = 3;//argc; 	
	myargv = (char**)ydk_malloc(sizeof(char*)*5);
	myargv[0]="zhexen.prc";
	myargv[1]="-iwad";
	myargv[2]=wad_filename;
	if (pwad_filename[0]){
		myargc = 5;
		myargv[3]="-file";
  		myargv[4]=pwad_filename;
	}
								
	YDK_HANDLE_EVENT_NOFUNC()
	ClearScreen();

	hexen_main (); 
    //myargv = NULL;//argv; 
    ydk_free(myargv);

 

   
	return 0;
}




/************************************/

void ClearScreen(void)
{
	UInt8 *vr;
	vr=(UInt8*)(g_pnobridge -> vram);
	for (int y=0;y<g_pnobridge -> display_height;y++)
	{
		memset(vr,0,g_pnobridge -> display_width*2);
		vr+=(g_pnobridge -> display_pitch)*2;
	}
}

void GpError ( char *s, ... ){
//	menu_info(s);
}

/*
 * The following functions provide hooks for stdin/stdout/stderr.
 * Applications may override them to do whatever they want. The
 * default implementation redirects console IO through ARM semihosting
 * interface.
 */
 
/*typedef unsigned long	__file_handle;
typedef void * __ref_con;
enum __io_results 
{
     __no_io_error,
     __io_error,
     __io_EOF         							
};

int
__close_console(__file_handle file)
{
    return __no_io_error;
}

int
__read_console(__file_handle file, unsigned char * buff, size_t * count, __ref_con ref_con)
{
    return __io_EOF;
}

int
__write_console(__file_handle file, unsigned char * buff, size_t * count, __ref_con ref_con)
{
    return __no_io_error;
}
*/
//#define __NOOUTPUT__
#ifdef __NOOUTPUT__
void Sys_PrintF( char *s, ...){}
void Sys_PrintF2( char *s, ...){}
#else
void Sys_PrintF( char *s, ...){
	va_list		argptr;
	char		text[1024];

	va_start (argptr,s);
	vsprintf (text, s, argptr);
	va_end (argptr);

	//menu_messageL(text);	
	menu_button(5,5,text,0,NULL,4);	
}

void Sys_PrintF2( char *s, ...){
	va_list		argptr;
	char		text[1024];

	va_start (argptr,s);
	vsprintf (text, s, argptr);
	va_end (argptr);

	menu_messageL(text);	
}
#endif
